/*
 * Funciones comunes, en principio no se han de cambiar 
 * Las funciones de tratamiento de los datos DCC están adaptadas de la librería NmraDCC
 */

void SetParmetro(){ // pasamos a la espera de un parametro que 
  #if defined(DEBUG) 
    Serial.println("SetParametro"); 
  #endif
  NoAccionDCC = true;  //Activamos flag de espera de dirección DCC y no actuar
  attachInterrupt(0, LeeDCC, CHANGE); // activamos interrupción
  digitalWrite(PinLED, HIGH);  
  for (int i = 1; i < 3000; i++) { // con retardo = 5ms, 3000 = 15s de espera para recibir orden
    if (datoOK == true) { // verificamos dato DCC correcto
      DirDCC=0;
      datoOK = false;
      detachInterrupt(0);  // desactivamos interrupción
      EvaluaDCC();         // evaluación de datos DCC leidos
      attachInterrupt(0, LeeDCC, CHANGE);  // activamos interrupción
    } 
    if (DirDCC != 0) break; // lectura de dirección valida
    delay(5);  // retardo 5ms
  }
  if (DirDCC != 0){  // si hay lectura de dirección valida
    NoAccionDCC = false;  // desactivamos lectura de nueva dirección
    #if defined(DEBUG)
      Serial.print("Parametro DCC recibido: "); Serial.println(DirDCC);
    #endif
    digitalWrite(PinLED, LOW); delay(150); // anunciamos lectura valida con destellos
    digitalWrite(PinLED, HIGH); delay(150);
    digitalWrite(PinLED, LOW); delay(150);     
    digitalWrite(PinLED, HIGH); delay(150);
  }
  NoAccionDCC = false;  
  digitalWrite(PinLED, LOW);  
}


void SetAddDCC(){ // pasamos a la espera de una dirección DCC para configurar el decoder
  #if defined(DEBUG) 
    Serial.println("SetAddDCC"); 
  #endif
  NoAccionDCC = true;  //Activamos flag de cambio de dirección 
  attachInterrupt(0, LeeDCC, CHANGE); // activamos interrupción
  digitalWrite(PinLED, HIGH);  
  for (int i = 1; i < 3000; i++) { // con retardo = 5ms, 3000 = 15s de espera para recibir orden
    if (datoOK == true) { // verificamos dato DCC correcto
      DirDCC=0;
      datoOK = false;
      detachInterrupt(0);  // desactivamos interrupción
      EvaluaDCC();         // evaluación de datos DCC leidos
      attachInterrupt(0, LeeDCC, CHANGE);  // activamos interrupción
      if (DirDCC > MaxDirDCC) DirDCC = 0;  // no se admiten direcciónes mayor de MaxDIR
    } 
    if (DirDCC != 0) break; // lectura de dirección valida
    delay(5);  // retardo 5ms
  }
  if (DirDCC != 0){  // si hay lectura de dirección valida
    AddrBaseDCC = DirDCC; // guardamos dirección DCC base
    WriteAddDCC(); // guardamos nueva dirección DCC base
    NoAccionDCC = false;  // desactivamos lectura de nueva dirección
    #if defined(DEBUG)
      Serial.print("Nueva dirección DCC: "); Serial.println(DirDCC);
    #endif
    digitalWrite(PinLED, LOW); delay(150); digitalWrite(PinLED, HIGH); delay(150); // anunciamos lectura valida con destellos
    digitalWrite(PinLED, LOW); delay(150); digitalWrite(PinLED, HIGH); delay(150); // anunciamos lectura valida con destellos
  }
  NoAccionDCC = false;  
  digitalWrite(PinLED, LOW);  
}

boolean EsPar(int num){  //Comprueba numero par/impar, lectura +/-
  if(num & 0x01)
    return false;
  else
    return true;
}

void LeeDCC() { // funcion de servicio de la interrupción en pin 2
  unsigned long micro = micros();
  if (digitalRead(PinDCC) == HIGH) {
    DCCMicros = micro;    //16MHz = 4 us
    return;  
  }
  if (datoLeido == true) contBit += 1;    // leemos 8 bits
  if (micro - DCCMicros < 75) {      //1-Bit leido; sobre 68us
    contByte += 1;            //ZÃ¤hlen der 1-Bit fÃ¼r PrÃ¤ambel erforderlich
    if (datoLeido == true && contBit <= 8) {    // guardamos bit leido en matriz
      bitWrite(dato[longDato], 8-contBit, 1);    // guardamos en matriz bit a bit
    }
    if (contBit > 8) {        // control lectura 8 bits
      contBit = 0; 
      contByte = 0;      
      datoLeido = false;        // dejamos de leer datos
      //XOR PrÃ¼fen:
      if (dato[longDato] != datoXor)  // XOR con el ultimo byte
        return;    //verwerfen!
      datoOK = true;  // fin evaluación de datos leidos
    }
  }  //Ende 1-Bit
  else {                  // leemos 0 bits
    if (datoLeido == true && contBit <= 8) {    // guardamos bit leido en matriz
      bitWrite(dato[longDato], 8-contBit, 0);    // guardamos en matriz bit a bit
    }
    if (contByte > 10) {   // identificacion paquete valido, reconocidos al menos 10 HIGH
      datoLeido = true;     // leemos datos validos
      longDato = 0;    // posicion de bits en array
      contBit = 0;       // contador1 lectura bits hasta 8
      datoXor = 0;          // XOR
    }
    if (contBit > 8) {    // letura bit 0, siempre despues de un 1
      contBit = 0;
      datoXor = datoXor ^ dato[longDato];  //XOR 
      longDato += 1;  // incrementamos Contador1 de bits
    }
    contByte = 0;    
  }  
}

void EvaluaDCC() {   // evaluación de los valores de los bits leídos.
  if (((dato[0] >> 6) == 0x02) && ((dato[1] >> 7) == 0x01)) {  
    direccionLeida = (((~dato[1]) & 0x70) << 2) | (dato[0] & 0x3F); // dirección
    direccionLeida = (direccionLeida << 2) | ((dato[1] >> 0x01) & 0x03);  // puerto max 4
    if (direccionLeida == 1823) {
      direccionLeida = 65535;
      DirDCC = 0;
      return;
    }   
    direccionLeida = direccionLeida-3;
    // si no estamos cambiando dirección DCC, la lectura ha de estar entre la dirección base + el numero de direcciones reservadas -1
    if(NoAccionDCC == false) { 
      if(direccionLeida < AddrBaseDCC | direccionLeida>(AddrBaseDCC + NumAddrDCC - 1)){  //filtramos direcciónes validas entre AddrBaseDCC y AddrBaseDCC + NumAddrDCC - 1   
        DirDCC = 0;
        return;
      }
    }  
    else {  // si estamos cambiando dirección DCC, la lectura ha de estar entre el valor de MaxDirDCC - el numero de direcciones reservadas 
      if(direccionLeida > MaxDirDCC - NumAddrDCC){  //filtramos direcciónes validas hasta MaxDirDCC-NumAddrDCC   
        DirDCC = 0;
        return;
      }    
    } 
    if (dato[1] & B1 == 1) PolDCC=false; else PolDCC=true;  // identificamos polaridad +/-
    if (direccionLeida == PdireccionLeida & PolDCC == PPolDCC) return; // cancelamos si repeticion
    // actualizamos valores
    DirDCC = direccionLeida;  
    #if defined(DEBUG) 
      Serial.print("Direccion leida....: ");Serial.println(direccionLeida); 
    #endif
    if (NoAccionDCC == false){  // si no estamos cambiando dirección DCC ejecutamos acciones
      PdireccionLeida = direccionLeida;  // guardamos dirección leida 
      PPolDCC = PolDCC;    // guardamos la polaridad leida
      EjecutaAcciones ();  // ejecutamos según dirección y polaridad leida
    }  
    return;
  }
  return; 
}

void WriteAddDCC(){ // se guarda la dirección base
  EEPROM.write(5, highByte(AddrBaseDCC)); // dirección DCC base byte H
  EEPROM.write(6, lowByte(AddrBaseDCC)); // dirección DCC base byte L  
}

void ReadAddDCC(){ // se lee la dirección base
  AddrBaseDCC = ((EEPROM.read(5)*256) + EEPROM.read(6));
}

void ShowAddDCC (){  // mostramos dirección DCC con destellos del LED
  int millar, centena, decena, unidad, Valor;
  millar = AddrBaseDCC/1000;
  centena = (AddrBaseDCC - millar*1000)/100;
  decena = (AddrBaseDCC - millar*1000 - centena*100)/10;
  unidad = (AddrBaseDCC - millar*1000 - centena*100 - decena*10);
  delay(1000);
  if (millar != 0) BlinkLED(millar);
  if (millar+centena != 0) BlinkLED(centena);
  if (millar+centena+decena != 0) BlinkLED(decena);
  BlinkLED(unidad);
}

void BlinkLED(int v){  // mostramos número con destellos del LED
  if (v == 0) {  // destello largo para mostrar 0
    digitalWrite(PinLED, HIGH); delay (1500); digitalWrite(PinLED, LOW);
  }
  else {
    while (v > 0) { // destellos cortos para mostrar cifra
      digitalWrite(PinLED, HIGH); delay (500); digitalWrite(PinLED, LOW); delay(500); 
      v--;
    }
  }
  delay(1200);
}
